import { Injectable, NgModule, Component, EventEmitter, Input, Output, defineInjectable } from '@angular/core';
import { CommonModule } from '@angular/common';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { FormsModule } from '@angular/forms';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-bootstrap-houratday-picker.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapHouratdayPickerService {
    constructor() { }
}
NgxBootstrapHouratdayPickerService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxBootstrapHouratdayPickerService.ctorParameters = () => [];
/** @nocollapse */ NgxBootstrapHouratdayPickerService.ngInjectableDef = defineInjectable({ factory: function NgxBootstrapHouratdayPickerService_Factory() { return new NgxBootstrapHouratdayPickerService(); }, token: NgxBootstrapHouratdayPickerService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-bootstrap-houratday-picker.config.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
const BS_NGX_HOURATDAY_HOURS_ALL = {
    0: true, 1: true, 2: true, 3: true, 4: true, 5: true, 6: true, 7: true,
    8: true, 9: true, 10: true, 11: true, 12: true, 13: true, 14: true, 15: true,
    16: true, 17: true, 18: true, 19: true, 20: true, 21: true, 22: true, 23: true
};
/** @type {?} */
const BS_NGX_HOURATDAY_HOURS_NONE = {
    0: false, 1: false, 2: false, 3: false, 4: false, 5: false, 6: false, 7: false,
    8: false, 9: false, 10: false, 11: false, 12: false, 13: false, 14: false, 15: false,
    16: false, 17: false, 18: false, 19: false, 20: false, 21: false, 22: false, 23: false
};
/** @type {?} */
const BS_NGX_HOURATDAY_CONFIG = {
    days: [
        {
            name: 'Senin',
            value: 0
        },
        {
            name: 'Selasa',
            value: 1
        },
        {
            name: 'Rabu',
            value: 2
        },
        {
            name: 'Kamis',
            value: 3
        },
        {
            name: 'Jumat',
            value: 4
        },
        {
            name: 'Sabtu',
            value: 5
        },
        {
            name: 'Minggu',
            value: 6
        }
    ],
    hours: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23],
    // You can set 0 to 23 or 1 to 24, based on your need.
    debug: false,
    // By default debug is off, when you set debug true (turn on debug) it will print debug info in browser console.
    callback: (/**
     * @return {?}
     */
    function () { }) // It will called when the picker changed
};
/** @type {?} */
const BS_NGX_HOURATDAY_PICKER_DEFAULT = [
    (/** @type {?} */ ({
        value: 0,
        hours: Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE)
    })),
    (/** @type {?} */ ({
        value: 1,
        hours: Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE)
    })),
    (/** @type {?} */ ({
        value: 2,
        hours: Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE)
    })),
    (/** @type {?} */ ({
        value: 3,
        hours: Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE)
    })),
    (/** @type {?} */ ({
        value: 4,
        hours: Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE)
    })),
    (/** @type {?} */ ({
        value: 5,
        hours: Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE)
    })),
    (/** @type {?} */ ({
        value: 6,
        hours: Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE)
    }))
];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-bootstrap-houratday-picker.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapHouratdayPickerComponent {
    constructor() {
        this.onDayClick = new EventEmitter();
        this.onHourClick = new EventEmitter();
        this.NgxBootstrapHouratdayChange = new EventEmitter();
        this.config = BS_NGX_HOURATDAY_CONFIG;
        this.list = [];
    }
    /**
     * @param {?} NgxBootstrapHouratday
     * @return {?}
     */
    set NgxBootstrapHouratday(NgxBootstrapHouratday) {
        if (NgxBootstrapHouratday == undefined) {
            this._NgxBootstrapHouratday = [];
        }
        else {
            this._NgxBootstrapHouratday = NgxBootstrapHouratday;
        }
        this.resyncPicker();
    }
    /**
     * @return {?}
     */
    get NgxBootstrapHouratday() {
        return this._NgxBootstrapHouratday;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.list = BS_NGX_HOURATDAY_PICKER_DEFAULT;
    }
    /**
     * @return {?}
     */
    clearPicker() {
        /** @type {?} */
        let parent = this;
        this.list.forEach((/**
         * @param {?} item
         * @param {?} i
         * @return {?}
         */
        function (item, i) {
            parent.list[i].selected = false;
            for (let key in parent.list[i].hours) {
                if (parent.list[i].hours.hasOwnProperty(key)) {
                    parent.list[i].hours[key] = false;
                }
            }
        }));
    }
    /**
     * @return {?}
     */
    resyncData() {
        /** @type {?} */
        const parent = this;
        /** @type {?} */
        let index = 0;
        this.list.forEach((/**
         * @param {?} item
         * @param {?} i
         * @return {?}
         */
        function (item, i) {
            /** @type {?} */
            let hasNext = false;
            for (let key in item.hours) {
                if (item.hours.hasOwnProperty(key) && item.hours[key]) {
                    if (parent._NgxBootstrapHouratday[index] == undefined) {
                        parent._NgxBootstrapHouratday[index] = (/** @type {?} */ ({}));
                    }
                    if (!hasNext) {
                        parent.list[i].selected = true;
                        parent._NgxBootstrapHouratday[index]._day = item.value;
                        parent._NgxBootstrapHouratday[index]._start = +key;
                    }
                    parent._NgxBootstrapHouratday[index]._end = +key;
                    hasNext = true;
                }
                else {
                    if (hasNext)
                        index++;
                    hasNext = false;
                }
            }
            if (hasNext) {
                index++;
            }
        }));
        for (let x = index; x < parent._NgxBootstrapHouratday.length; x++) {
            parent._NgxBootstrapHouratday.pop();
        }
        this.NgxBootstrapHouratdayChange.emit(this._NgxBootstrapHouratday);
    }
    /**
     * @return {?}
     */
    resyncPicker() {
        /** @type {?} */
        const parent = this;
        this.clearPicker();
        this._NgxBootstrapHouratday.forEach((/**
         * @param {?} data
         * @param {?} i
         * @return {?}
         */
        function (data, i) {
            if (data._day < 0 || data._day > 6)
                return;
            if (parent.list[data._day].hours) {
                // NORMALIZE
                if (data._start < 0)
                    data._start = 0;
                if (data._start > 23)
                    data._start = 23;
                if (data._end < 0)
                    data._end = 0;
                if (data._end > 23)
                    data._end = 23;
                if (data._start > data._end)
                    data._end = data._start;
                parent.list[data._day].selected = true;
                for (let x = data._start; x <= data._end; x++) {
                    parent.list[data._day].hours[x] = true;
                }
            }
        }));
    }
    /**
     * @param {?} i
     * @return {?}
     */
    onDayClicked(i) {
        if (this.list[i].selected) {
            this.list[i].selected = false;
            this.list[i].hours = Object.assign({}, BS_NGX_HOURATDAY_HOURS_NONE);
        }
        else {
            this.list[i].hours = Object.assign({}, BS_NGX_HOURATDAY_HOURS_ALL);
        }
        this.resyncData();
        this.onDayClick.emit(this.list[i]);
    }
    /**
     * @param {?} i
     * @param {?} j
     * @return {?}
     */
    onHourClicked(i, j) {
        this.resyncData();
        this.onHourClick.emit({ day: this.list[i]._day, hour: j, state: this.list[i].hours[j] });
    }
}
NgxBootstrapHouratdayPickerComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-bootstrap-houratday-picker',
                template: "<div class=\"card\">\r\n  <div class=\"card-body\">\r\n    <div class=\"btn-group btn-group-toggle\" role=\"group\" *ngFor=\"let day of config.days;index as i\">\r\n      <button type=\"button\" class=\"btn btn-primary\" (click)=\"onDayClicked(i)\">{{ day.name }}</button>\r\n      <label class=\"btn-info\" ngbButtonLabel *ngFor=\"let hour of config.hours;index as j\">\r\n        <input type=\"checkbox\" ngbButton [(ngModel)]=\"list[i].hours[j]\" (ngModelChange)=\"onHourClicked(i,j)\" [valueChecked]=\"true\" [valueUnChecked]=\"false\"> {{ hour }}\r\n      </label>\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                styles: [".card-body{position:relative;max-width:100%;overflow-x:visible;overflow-y:hidden}.card-body .btn-group.btn-group-toggle:first-child>button:first-child{border-radius:5px 0 0}.card-body .btn-group.btn-group-toggle:first-child>label:last-child{border-radius:0 5px 0 0}.card-body .btn-group.btn-group-toggle:last-child>button:first-child{border-radius:0 0 0 5px}.card-body .btn-group.btn-group-toggle:last-child>label:last-child{border-radius:0 0 5px}.card-body .btn-group.btn-group-toggle button,.card-body .btn-group.btn-group-toggle label{padding:5px;font-size:12px;border-radius:0}.card-body .btn-group.btn-group-toggle button:first-child{width:75px}.card-body .btn-group.btn-group-toggle label{width:30px}"]
            }] }
];
/** @nocollapse */
NgxBootstrapHouratdayPickerComponent.ctorParameters = () => [];
NgxBootstrapHouratdayPickerComponent.propDecorators = {
    onDayClick: [{ type: Output }],
    onHourClick: [{ type: Output }],
    NgxBootstrapHouratday: [{ type: Input }],
    NgxBootstrapHouratdayChange: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-bootstrap-houratday-picker.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapHouratdayPickerModule {
}
NgxBootstrapHouratdayPickerModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NgxBootstrapHouratdayPickerComponent
                ],
                imports: [
                    CommonModule,
                    FormsModule,
                    NgbModule,
                ],
                exports: [
                    NgxBootstrapHouratdayPickerComponent,
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: verzth-ngx-bootstrap-houratday-picker.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapHouratdayPickerService, NgxBootstrapHouratdayPickerComponent, NgxBootstrapHouratdayPickerModule };

//# sourceMappingURL=verzth-ngx-bootstrap-houratday-picker.js.map